using GMW_data;
using SteamWare;
using System;
using System.Web.UI;

namespace GMW.WebUserControls
{
  public partial class mod_sterrTaglioFC : System.Web.UI.UserControl
  {
    /// <summary>
    /// flusso associato (hard coded) a sterrati
    /// </summary>
    protected string flusso = "ST";
    /// <summary>
    /// stato associato (hard coded) a  sterrati
    /// </summary>
    protected string statoUDC = "Sterr";
    /// <summary>
    /// tipo di evento associato alla creazione dell'UDC
    /// </summary>
    protected string eventoUDC = "UDC_STTA";
    /// <summary>
    /// tipo di evento associato alla modifica qta dell'UDC
    /// </summary>
    protected string eventoUDC_qta = "UDC_QTY";
    /// <summary>
    /// dati x verifica CodSoggetto / matricola
    /// </summary>
    protected string preCodSogg = memLayer.ML.AppConf["prefCodSogg"];
    public event EventHandler eh_reqUpdate;
    /// <summary>
    /// stringa UID univoca
    /// </summary>
    public string uid
    {
      get
      {
        return this.UniqueID.Replace("$", "_").Replace("-", "_");
      }
    }
    /// <summary>
    /// caricamento pagina
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
      if (!Page.IsPostBack)
      {
        qta = 0;
        // imposto destAL
        destAL = AlByCella;
        traduciObj();
        idxCella = Postazione.currIdxCella;
        checkNumKeyIn();
      }
      setVisibility();
      doChecks();
    }
    /// <summary>
    /// verifico se ci sia in sessione un input da NumKeyb e nel caso lometto in barcodeIn e processo...
    /// </summary>
    private void checkNumKeyIn()
    {
      if (memLayer.ML.isInSessionObject("numKeyIn"))
      {
        barcodeIn = memLayer.ML.StringSessionObj("numKeyIn");
        // svuoto valore in sessione...
        memLayer.ML.emptySessionVal("numKeyIn");
        // controllo barcode...
        checkBarcode();
      }
    }
    /// <summary>
    /// IDX cella associata alla linea corrente
    /// </summary>
    protected int idxCella
    {
      get
      {
        int answ = 0;
        if (memLayer.ML.isInSessionObject("IdxCellaLineaST_FC"))
        {
          answ = memLayer.ML.IntSessionObj("IdxCellaLineaST_FC");
        }
        return answ;
      }
      set
      {
        memLayer.ML.setSessionVal("IdxCellaLineaST_FC", value);
      }
    }
    /// <summary>
    /// Codice AL associato alla cella corrente...
    /// </summary>
    protected string AlByCella
    {
      get
      {
        string answ = "";
        try
        {
          answ = string.Format("ALS00{0}", Postazione.currCodCella);
          // controllo se esista AL sennò lo creo...
          if (MagClass.magazzino.taEA.getByAL(answ).Rows.Count == 0)
          {
            MagClass.magazzino.taEA.Insert(answ, true, DateTime.Now, MagClass.magazzino.CodSoggCurrUser, "", "", "", 0);
          }
        }
        catch
        { }
        return answ;
      }
    }
    /// <summary>
    /// Codice AL target
    /// </summary>
    protected string destAL
    {
      get
      {
        return lblAL.Text.Trim();
      }
      set
      {
        lblAL.Text = value;
      }
    }
    /// <summary>
    /// richiesta (ri)stampa UDC
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public void ristampa()
    {
      bool fatto = false;
      // registro ri-stampa UDC
      DateTime adesso = DateTime.Now;
      // calcolo particolare...
      DS_magazzino.ElencoCartelliniRow rigaUDC;
      string particolare = "";
      try
      {
        rigaUDC = MagClass.magazzino.taCartellini.getByUdc(udcReq)[0];
        particolare = rigaUDC.Particolare;
        fatto = MagClass.magazzino.ristampaUdc(udcReq, Postazione.printer, Request.UserHostName);
      }
      catch
      {
        logger.lg.scriviLog(string.Format("Errore recupero particolare UDC Sterratura FC {0}", udcReq), tipoLog.EXCEPTION);
      }
      if (fatto) MagClass.magazzino.taSAO.insertQuery(adesso, MagClass.magazzino.CodSoggCurrUser, Postazione.name, Postazione.IP, udcReq, particolare, "stampaUDC", "Ri-Stampato UDC Sterratura Fuoriciclo");
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }
    /// <summary>
    /// udc da stampare
    /// </summary>
    protected string udcReq
    {
      get
      {
        return memLayer.ML.StringSessionObj("udcSelSAO");
      }
    }
    /// <summary>
    /// controlla particolare selezionato
    /// </summary>
    private void checkParticolare()
    {
      if (currParticolare != "")
      {
        lblParticolareAttivo.Text = string.Format("Particolare selezionato <b>{0}</b>", currParticolare);
        // aggiungo descrizione del particolare
        string descr = "";
        string disegno = "";
        try
        {
          DS_magazzino.AnagParticolariRow riga = MagClass.magazzino.taAnagPart.likeSearch(currParticolare, memLayer.ML.StringSessionObj("CodCS"))[0];
          descr = riga.DescParticolare;
          disegno = string.Format("( {0} )", riga.DisegnoGrezzo);
        }
        catch
        { }
        lblDescrAttivo.Text = descr;
        lblDisegno.Text = disegno;
      }
      else
      {
        lblParticolareAttivo.Text = "...";
        lblDescrAttivo.Text = "";
        lblDisegno.Text = "";
      }
    }
    /// <summary>
    /// effettua controlli visibilità
    /// </summary>
    private void doChecks()
    {
      checkBarcode();
      checkStampa();
      checkParticolare();
    }
    /// <summary>
    /// sistemo labels oggetti
    /// </summary>
    private void traduciObj()
    {
      //txtBox
      txtQta.Text = memLayer.ML.cdv("QtaImballoSterr");
      // buttons
      btnEmptyNote.Text = traduci("btnEmptyNote");
    }
    /// <summary>
    /// restituisce il nome della pagina corrente
    /// </summary>
    protected string PagCorrente
    {
      get
      {
        string answ = "";
        Uri MyUrl = Request.Url;
        string delimStr = "/";
        char[] delimiter = delimStr.ToCharArray();
        string[] finalUrl = MyUrl.LocalPath.ToString().Split(delimiter);
        int n = finalUrl.Length;
        answ = finalUrl[n - 1].ToString();
        DataLayer_AnagGen.PermessiRow riga = (DataLayer_AnagGen.PermessiRow)user_std.UtSn.permessi.Select(string.Format("URL = '{0}'", answ))[0];
        answ = riga.NOME;
        return answ;
      }
    }
    /// <summary>
    /// wrapper traduzione
    /// </summary>
    /// <param name="lemma"></param>
    /// <returns></returns>
    public string traduci(object lemma)
    {
      return user_std.UtSn.Traduci(lemma.ToString());
    }
    /// <summary>
    /// indica il codice articolo correntemente selezionato
    /// </summary>
    protected string currParticolare
    {
      get
      {
        return memLayer.ML.StringSessionObj(string.Format("currParticolare_{0}", uid));
      }
      set
      {
        memLayer.ML.setSessionVal(string.Format("currParticolare_{0}", uid), value, memLayer.ML.confReadBool("keepParticolareSel"));
      }
    }
    /// <summary>
    /// indica UDC correntemente selezionato
    /// </summary>
    protected string currUDC
    {
      get
      {
        return memLayer.ML.StringSessionObj(string.Format("UDC_{0}", uid));
      }
      set
      {
        memLayer.ML.setSessionVal(string.Format("UDC_{0}", uid), value, memLayer.ML.confReadBool("keepParticolareSel"));
      }
    }
    /// <summary>
    /// indica se i caratteri vadano forzati a maiuscoli
    /// </summary>
    public bool forceUppercase
    {
      get
      {
        return memLayer.ML.confReadBool("forceUppercase");
      }
    }
    /// <summary>
    ///  num pezzi dell'ultimo UDC del particolare generato
    /// </summary>
    public int pezziUdc
    {
      get
      {
        int answ = 0;
        try
        {
          answ = (int)MagClass.magazzino.taCartellini.getLastByParticolareStato(memLayer.ML.StringSessionObj("CodCS"), currParticolare, statoUDC, false)[0].Qta;
        }
        catch
        { }
        return answ;
      }
    }
    /// <summary>
    /// decodifica il tipo barcode acquisito
    /// </summary>
    public tipoCodiceBarcode tipoBCode
    {
      get
      {
        tipoCodiceBarcode answ = tipoCodiceBarcode.ND;
        int trovati = 0;
        int matricola = -1;
        // provo a convertire in intero barcode x verifica eventuale matricola...
        try
        {
          matricola = Convert.ToInt32(barcodeIn);
        }
        catch
        { }
        // controllo non si tratti di un comando...
        string preCmd = memLayer.ML.AppConf["prefComandi"];
        if (barcodeIn.StartsWith(preCmd))
        {
          answ = tipoCodiceBarcode.Comando;
        }
        else if ((TermClass.Ter.riconosciBarcode(barcodeIn) == tipoCodiceBarcode.Particolare)) // è un particolare...
        {
          answ = tipoCodiceBarcode.Particolare;
        }
        else if (barcodeIn.StartsWith(preCodSogg))
        {
          // cerco cod soggetto...
          if (DataProxy.obj.taTrascSogg.getByKey(barcodeIn, 0).Rows.Count == 1)
          {
            answ = tipoCodiceBarcode.Operatore;
          }
        }
        else if (matricola >= 0)
        {
          if (DataProxy.obj.taTrascSogg.getByKey("", matricola).Rows.Count == 1)
          {
            answ = tipoCodiceBarcode.Operatore;
          }
        }
        else
        {
          try
          {
            // cerco tra gitterbox (UDC)...
            trovati = MagClass.magazzino.taCartellini.getByUdc(barcodeIn).Rows.Count;
            if (trovati > 0)
            {
              answ = tipoCodiceBarcode.UDC;
            }
          }
          catch
          {
          }
        }
        return answ;
      }
    }
    /// <summary>
    /// valore barcode
    /// </summary>
    public string barcodeIn
    {
      get
      {
        return txtBarcode.Text.Trim();
      }
      set
      {
        txtBarcode.Text = value;
      }
    }
    /// <summary>
    /// qta pezzi TOTALE
    /// </summary>
    public int qta
    {
      get
      {
        int qta = 0;
        try
        {
          qta = Convert.ToInt32(txtQta.Text.Trim());
        }
        catch
        { }
        return qta;
      }
      set
      {
        txtQta.Text = value.ToString();
      }
    }
    /// <summary>
    /// controlla se ci sia un barcode
    /// </summary>
    private void checkBarcode()
    {
      if (barcodeIn != "")
      {
        Postazione.messaggiText = string.Format("Barcode digitato: {0}", barcodeIn);
        switch (tipoBCode)
        {
          case tipoCodiceBarcode.Particolare:
            // 2015.01.29: particolare accettato SOLO SE contiene "*GRZ"
            if (barcodeIn.IndexOf("GRZ") >= 0)
            {
              // imposto il particolare corrente
              currParticolare = barcodeIn;
              // controllo SE esista già UDC in AL dest... altrimenti CREO!!!
              string udcDest = checkCreaUDC();
            }
            else
            {
              Postazione.messaggiText += " - errore <b>particolare non è grezzo</b>!";
              Postazione.CssClass = "stileComandoND";
            }
            break;
          case tipoCodiceBarcode.UDC:
            break;
          case tipoCodiceBarcode.Operatore:
            // calcolo matricola utente
            int MatrUtente = -1;
            string preCodSogg = memLayer.ML.AppConf["prefCodSogg"];
            if (barcodeIn.StartsWith(preCodSogg))
            {
              MatrUtente = DataProxy.obj.taTrascSogg.getByKey(barcodeIn, 0)[0].CodMatricola;
            }
            else
            {
              MatrUtente = Convert.ToInt32(barcodeIn);
            }
            if (MatrUtente >= 0)
            {
              // salvo in sessione operatore con AUTH
              OpAuth.startOpAuth(MatrUtente);
              // mostro che ho autorizzato...
              Postazione.messaggiText += traduci("userAuthRec");
              Postazione.CssClass = "stileComandoOk";
              Response.Redirect(user_std.pagCorrente);
            }
            else
            {
              Postazione.messaggiText += " - codice <b>non riconosciuto</b>!";
              Postazione.CssClass = "stileComandoND";
            }
            break;
          default:
            // cerco se sia "0" = reset utente...
            if (barcodeIn == memLayer.ML.CRS("resetCodSogg"))
            {
              // salvo in sessione operatore con AUTH
              OpAuth.stopAuth();
              // mostro che ho autorizzato...
              Postazione.messaggiText += traduci("userAuthRem");
              Postazione.CssClass = "stileComandoOk";
              Response.Redirect(user_std.pagCorrente);
            }
            Postazione.messaggiText += " - codice <b>non riconosciuto</b>!";
            Postazione.CssClass = "stileComandoND";
            break;
        }
        barcodeIn = "";
      }
#if false
            else
            {
                Postazione.messaggiText = traduci("AttesaBCode");
                Postazione.CssClass = "stileAttesa";
            } 
#endif
      txtBarcode.Focus();
    }

    /// <summary>
    /// effettua consumo UDC
    /// </summary>
    /// <param name="oldUdc"></param>
    private void consumaUdc(string oldUdc)
    {
      // se è consumabile (IdxPosizione > 0)...
      if (MagClass.magazzino.udcMpIsConsumabile(oldUdc))
      {
        // consumo UDC
        MagClass.magazzino.scaricaUdcMpWip(oldUdc, Request.UserHostName);
      }
    }

    /// <summary>
    /// crea eventualmente UDC per particolare in AL di destinazione e restituisce codice UDC
    /// </summary>
    /// <param name="qty"></param>
    /// <param name="particolare"></param>
    private string checkCreaUDC()
    {
      string udcDest = "";
      DateTime adesso = DateTime.Now;
      // verifico se ho già quel particolare tra quelli dell'AL...
      try
      {
        udcDest = MagClass.magazzino.taCartellini.getByParticolareAL(currParticolare, destAL)[0].UDC;
      }
      catch
      {
        udcDest = "";
      }
      if (string.IsNullOrEmpty(udcDest))
      {
        try
        {
          // creo nuovo UDC ST... direttamente in posizione definitiva e con un evento differente...
          udcDest = MagClass.magazzino.creaUdc(flusso, "", currParticolare, "", "", "", "", "", 0, memLayer.ML.cdv("CodImballoSterr"), "U", MagClass.magazzino.CodSoggCurrUser, 0, 0, 0, adesso, 0, statoUDC, memLayer.ML.cdvi("IdxPosizioneSterratiTemp"), "IdxPosizioneSterratiTemp", eventoUDC, "", "", adesso.Year, Request.UserHostName);
          // associo UDC a AL...
          MagClass.magazzino.taAL2UDC.Insert(destAL, udcDest, adesso, MagClass.magazzino.CodSoggCurrUser);
        }
        catch (Exception exc)
        {
          logger.lg.scriviLog(string.Format("Errore in creazione UDC temp ST x travaso: {0}{1}", Environment.NewLine, exc));
        }
      }
      if (udcDest != "")
      {
        Postazione.CssClass = "stileAttesa";
        Postazione.warningText = "";
        Postazione.messaggiText = traduci("partAdded");
      }
      else
      {
        Postazione.CssClass = "stileComandoKo";
        Postazione.warningText = traduci("ErroreUdcDest");
      }
      grViewDest.DataBind();
      return udcDest;
    }

    /// <summary>
    /// aggiorna tabella + focus a barcode
    /// </summary>
    public void doUpdate()
    {
      idxCella = Postazione.currIdxCella;
      destAL = AlByCella;
      setVisibility();
      checkStampa();
      grViewDest.DataBind();
      txtBarcode.Focus();
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }
    /// <summary>
    /// controllo l'abilitazione alla stampa UDC:
    /// - particolare ok
    /// - qta > 0
    /// - udc da consumo totale/parziale
    /// altrimenti disabilito btn stampa
    /// </summary>
    private void checkStampa()
    {
      bool stampaOk = false;
      //controllo siano inseriti valori qta
      if (numCesta != "" && numCesta != "0000" && qta > 0 && grViewDest.SelectedIndex >= 0)
      {
        // controllo ci siano particolare
        if (currParticolare != "")
        {
          stampaOk = true;
          txtNote.Focus();
        }
      }
      divNote.Visible = stampaOk;
    }
    /// <summary>
    /// genera i barcode di
    /// - trattamenti
    /// - nuovo x pezzi liquidi
    /// e lancia la relativa stampa
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnStampa_Click(object sender, EventArgs e)
    {
      bool needsRedirect = false;
      string[] stringSeparators = new string[] { "#" };
      // verifico postazione x procedere...
      if (Postazione.printer != "n.d.")
      {
        // verifico auth utente OPPURE se NON sia richiesta...
        if (OpAuth.isAuth || !OpAuth.opAuthReq)
        {
          DateTime adesso = DateTime.Now;

          string noteTrim = txtNote.Text.Trim();
          string lineaCesta = string.Format("FUORICICLO | {0} | cesta: {1}", Postazione.currNomeLinea, numCesta);
          noteTrim = string.Format("{0}{1}{2}", lineaCesta, Environment.NewLine, noteTrim);
          //string noteTrim = txtNote.Text.Trim();
          //noteTrim = string.Format("FUORICICLO{0}{1}", Environment.NewLine, noteTrim);

          // effettuo controlli che cod_soggetto, cod particolare e destAL siano disponibili...
          if (MagClass.magazzino.CodSoggCurrUser != "" && currParticolare != "" && destAL != "ALS00")
          {
            // aggiorno note e  posizione da temp a definitiv x UDC...
            MagClass.magazzino.updateNotePosizioneDataUDC(currUDC, noteTrim, memLayer.ML.cdvi("IdxPosizioneSterrati"), DateTime.Now);

            if (OpAuth.isAuth)
            {
              // salvo attributo dell'OpAuth...
              MagClass.magazzino.taAtt2UDC.Insert(currUDC, memLayer.ML.CRS("attrOpAuth"), OpAuth.currAuth.CodSoggetto, DateTime.Now, MagClass.magazzino.CodSoggCurrUser);
              // consumo una auth...
              OpAuth.currAuth.remAuth--;
              if (OpAuth.currAuth.remAuth == 0)
              {
                OpAuth.stopAuth();
                needsRedirect = true;
              }
            }

            // registro creazione nuovo UDC
            MagClass.magazzino.taSAO.insertQuery(adesso, MagClass.magazzino.CodSoggCurrUser, Postazione.name, Postazione.IP, currUDC, currParticolare, "creaUDC", string.Format("Creato nuovo UDC Sterr Taglio FC, qta: {0} {1}", qta, ""));
            // metto attributo FC
            MagClass.magazzino.taAtt2UDC.Insert(currUDC, "FC", "", DateTime.Now, MagClass.magazzino.CodSoggCurrUser);
            // tolgo UDC da AL corrente...
            MagClass.magazzino.taAL2UDC.deleteQuery(destAL, currUDC);

            // ora stampo il nuovo cartellino!!!
            MagClass.magazzino.stampaUdc(currUDC, Postazione.printer, tipoCartellino.cartSterr, Request.UserHostName);
            // incremento timing...
            adesso = adesso.AddSeconds(2);
            // registro stampa nuovo UDC
            MagClass.magazzino.taSAO.insertQuery(adesso, MagClass.magazzino.CodSoggCurrUser, Postazione.name, Postazione.IP, currUDC, currParticolare, "stampaUDC", "Stampato UDC Sterrato FUORICICLO");
            // svuoto campo cesta...
            numCesta = "";
            // resetto
            doResetData();
          }
          else
          {
            httpLog(string.Format("STERRATI FC, Errore persi utente/particolare, ricarico!"), tipoLog.ERROR);
            Response.Redirect("~/login.aspx");
          }
        }
        else
        {
          Postazione.messaggiText = traduci("noOpAuth");
          Postazione.CssClass = "stileComandoKo";
          httpLog(string.Format("Errore manca OpAuth x UDC anime"), tipoLog.ERROR);
        }
      }
      else
      {
        Response.Redirect("~/menu.aspx");
      }
      doUpdate();
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
      if (needsRedirect)
      {
        Response.Redirect(user_std.pagCorrente);
      }
    }
    /// <summary>
    /// effettua il consumo di tutti gli UDC inviati come array di stringhe
    /// </summary>
    /// <param name="UDC_P"></param>
    private void consumaUdc(string[] UDC_P)
    {
      if (UDC_P.Length > 0)
      {
        // ciclo
        foreach (string udc_p in UDC_P)
        {
          // se UDC è NON vuoto ed esiste
          if (udc_p != "" && MagClass.magazzino.checkUDC(udc_p))
          {
            // se è consumabile (IdxPosizione > 0)...
            if (MagClass.magazzino.udcMpIsConsumabile(udc_p))
            {
              // consumo UDC
              MagClass.magazzino.scaricaUdcMpWip(udc_p, Request.UserHostName);
              // sposta UDC da posizione corrente a nessuna...
            }
          }
        }
      }
    }
    /// <summary>
    ///associa nuovo UDC ad elenco UDC
    /// </summary>
    /// <param name="newUdcChild">UDC da associare come child</param>
    /// <param name="UDC_P">vettore di UDC da associare come parent</param>
    private void associaUdc(string newUdcChild, string[] UDC_P)
    {
      if (UDC_P.Length > 0)
      {
        // ciclo
        foreach (string udc_p in UDC_P)
        {
          // se UDC è NON vuoto ed esiste
          if (udc_p != "" && MagClass.magazzino.checkUDC(udc_p))
          {
            MagClass.magazzino.associaUdcParent(newUdcChild, udc_p);
          }
        }
      }
    }
    /// <summary>
    /// verifica che il vettore di UDC abbia tutto lo stesso particolare e lo restituisce, altrimenti restituisce ""
    /// </summary>
    /// <param name="UDC_P">vettore di UDC da verificare</param>
    private string checkPartUDC(string[] UDC_P)
    {
      string answ = "";
      if (UDC_P.Length > 0)
      {
        // imposto il primo particolare...
        answ = MagClass.magazzino.getParticolareByUDC(UDC_P[0]);
        // ciclo
        foreach (string udc_p in UDC_P)
        {
          if (MagClass.magazzino.getParticolareByUDC(udc_p) != answ) answ = ""; // se uno è diverso "azzero"
        }
      }
      return answ;
    }
    /// <summary>
    /// wrapper per log con salvataggio dell'IP del chiamante
    /// </summary>
    /// <param name="_testoPre"></param>
    /// <returns></returns>
    public bool httpLog(string _testoPre)
    {
      bool answ = false;
      logger.lg.scriviLog(Postazione.IP + _testoPre);
      return answ;
    }
    /// <summary>
    /// wrapper per log con salvataggio dell'IP del chiamante
    /// </summary>
    /// <param name="_testoPre"></param>
    /// <returns></returns>
    public bool httpLog(string testoLog, tipoLog tipo)
    {
      bool answ = false;
      logger.lg.scriviLog(Postazione.IP + testoLog, tipo);
      return answ;
    }
    /// <summary>
    /// effettua reset dati
    /// </summary>
    public void doResetData()
    {
      // resetto i dati QtaTot e particolare...
      qta = 0;
      currParticolare = "";
      txtQta.Text = "";
      grViewDest.SelectedIndex = -1;
      doChecks();
    }
    /// <summary>
    /// svuoto le note
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnEmptyNote_Click(object sender, EventArgs e)
    {
      txtNote.Text = "";
      Postazione.messaggiText = traduci("AttesaBCode");
      Postazione.CssClass = "stileAttesa";
      // raise dell'evento
      if (eh_reqUpdate != null)
      {
        eh_reqUpdate(this, new EventArgs());
      }
    }
    /// <summary>
    /// passo alla modalità IN
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnIn_Click(object sender, EventArgs e)
    {
      Response.Redirect("SterrTaglioIN.aspx");
    }

    /// <summary>
    /// effettua refresh (su db) del blocco postazione
    /// </summary>
    /// <param name="codLinea"></param>
    private void refreshBloccoPost(string codLinea)
    {
      // resetto usi linee precedenti..
      MagClass.magazzino.taAL.resetPost(Postazione.name);
      // se la linea non è "base" = "Sel linea", finisce x "0"
      if (codLinea.Substring(codLinea.Length - 1) != "0")
      {
        // salvo su DB che sto occupando linea...
        MagClass.magazzino.taAL.updatePost(codLinea, Postazione.name);
      }
    }

    /// <summary>
    /// aggiorno ods al binding..
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ods_DataBinding(object sender, EventArgs e)
    {
      // fix dell'ODS
      checkFixOds();
    }
    /// <summary>
    /// verifica se attivo filtro company e imposta ods di conseguenza...
    /// </summary>
    private void checkFixOds()
    {
    }
    /// <summary>
    /// evento selezione grView destinazione: ricarico dati!
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void grViewDest_SelectedIndexChanged(object sender, EventArgs e)
    {
      // ricarico dati dell'UDC come particolare e quantità...
      currUDC = grViewDest.SelectedDataKey["UDC"].ToString();
      if (MagClass.magazzino.checkUDC(currUDC))
      {
        currParticolare = DataProxy.obj.taCartellini.stp_getByUdc(currUDC)[0].Particolare;
        qta = Convert.ToInt32(DataProxy.obj.taCartellini.stp_getByUdc(currUDC)[0].Qta);
      }
      Postazione.messaggiText = traduci("partSelected");
      Postazione.warningText = "";
      Postazione.CssClass = "stileComandoOk";
      doChecks();
      doUpdate();
      // fisso focus su note!
      txtNote.Focus();
    }
    /// <summary>
    /// sistema modalità input
    /// </summary>
    private void setVisibility()
    {
      bool showBtn = false;
      // ora controllo btn quantità
      if (grViewDest.SelectedIndex >= 0)
      {
        showBtn = true;
      }
      divQta.Visible = showBtn;
    }
    /// <summary>
    /// reset della selezione
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnReset_Click(object sender, EventArgs e)
    {
      grViewDest.SelectedIndex = -1;
      qta = 0;
      currUDC = "";
      currParticolare = "";
      setVisibility();
      doUpdate();
    }
    /// <summary>
    /// update Qty x UDC selezionato...
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbtUpdQty_Click(object sender, EventArgs e)
    {
      aggiornaQta();
    }

    private void aggiornaQta()
    {
      MagClass.magazzino.taCartellini.updateQty(currUDC, MagClass.magazzino.CodSoggCurrUser, "U", eventoUDC_qta, qta);
      currUDC = "";
      currParticolare = "";
      grViewDest.SelectedIndex = -1;
      setVisibility();
      doUpdate();
    }
    /// <summary>
    /// Numero cesta inserito
    /// </summary>
    public string numCesta
    {
      get
      {
        return txtCesta.Text.Trim();
      }
      set
      {
        txtCesta.Text = value;
      }
    }
    /// <summary>
    /// evento cambio num cesta/grappolo
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void txtCesta_TextChanged(object sender, EventArgs e)
    {
      txtCesta.Text = txtCesta.Text.ToUpper().Trim().PadLeft(4, '0').Substring(0, 4);
      doUpdate();
    }
    /// <summary>
    /// fornisce in output la corretta classe css x icona
    /// </summary>
    /// <param name="qta"></param>
    /// <returns></returns>
    public string cssGlyphByQty(object _qta)
    {
      string answ = "fa fa-pencil";
      int qtaUDC = 0;
      try
      {
        qtaUDC = Convert.ToInt32(_qta);
      }
      catch { }
      if (qtaUDC > 0)
      {
        answ = "fa fa-print";
      }
      return answ;
    }
    /// <summary>
    /// determina se sia possibile cancellare un record, se qta > 0
    /// </summary>
    /// <param name="_qta"></param>
    /// <returns></returns>
    public bool canDelete(object _qta)
    {
      bool answ = false;
      try
      {
        answ = Convert.ToInt32(_qta) == 0;
      }
      catch
      { }
      return answ;
    }

    /// <summary>
    /// evento cambio qta
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void txtQta_TextChanged(object sender, EventArgs e)
    {
      aggiornaQta();
    }
  }
}